// Pecon7
// Duck Cannon

datablock audioProfile(duckCannonChargeSound)
{
	filename = "./charge.wav";
	description = "AudioClosest3D";
	preload = true;
};

datablock audioProfile(duckCannonFireSound)
{
	filename = "./fire.wav";
	description = "AudioClosest3D";
	preload = true;
};

datablock audioProfile(duckCannonExplosionSound)
{
	filename = "./boom.wav";
	description = "AudioClose3D";
	preload = true;
};

datablock audioProfile(duckCannonQuackSound)
{
	filename = "./quack.wav";
	description = "AudioClose3D";
	preload = true;
};

datablock particleData(duckAnimationFrame2)
{
	textureName = "./spritesheet/frame2.png";
};

datablock particleData(duckAnimationFrame3)
{
	textureName = "./spritesheet/frame3.png";
};
datablock particleData(duckAnimationFrame4)
{
	textureName = "./spritesheet/frame4.png";
};
datablock particleData(duckAnimationFrame5)
{
	textureName = "./spritesheet/frame5.png";
};
datablock particleData(duckAnimationFrame6)
{
	textureName = "./spritesheet/frame6.png";
};
datablock particleData(duckAnimationFrame7)
{
	textureName = "./spritesheet/frame7.png";
};
datablock particleData(duckAnimationFrame8)
{
	textureName = "./spritesheet/frame8.png";
};
datablock particleData(duckAnimationFrame9)
{
	textureName = "./spritesheet/frame9.png";
};
datablock particleData(duckAnimationFrame10)
{
	textureName = "./spritesheet/frame10.png";
};
datablock particleData(duckAnimationFrame11)
{
	textureName = "./spritesheet/frame11.png";
};
datablock particleData(duckAnimationFrame12)
{
	textureName = "./spritesheet/frame12.png";
};
datablock particleData(duckAnimationFrame13)
{
	textureName = "./spritesheet/frame13.png";
};
datablock particleData(duckAnimationFrame14)
{
	textureName = "./spritesheet/frame14.png";
};
datablock particleData(duckAnimationFrame15)
{
	textureName = "./spritesheet/frame15.png";
};
datablock particleData(duckAnimationFrame16)
{
	textureName = "./spritesheet/frame16.png";
};
datablock particleData(duckAnimationFrame17)
{
	textureName = "./spritesheet/frame17.png";
};
datablock particleData(duckAnimationFrame18)
{
	textureName = "./spritesheet/frame18.png";
};
datablock particleData(duckAnimationFrame19)
{
	textureName = "./spritesheet/frame19.png";
};
datablock particleData(duckAnimationFrame20)
{
	textureName = "./spritesheet/frame20.png";
};
datablock particleData(duckAnimationFrame21)
{
	textureName = "./spritesheet/frame21.png";
};


datablock particleData(duckExplosionParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifeTime = 1000; 
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	textureName		= "./spritesheet/frame1.png";

	animTexName[0]= "./spritesheet/frame1.png";
	animTexName[1]= "./spritesheet/frame2.png";
	animTexName[2]= "./spritesheet/frame3.png";
	animTexName[3]= "./spritesheet/frame4.png";
	animTexName[4]= "./spritesheet/frame5.png";
	animTexName[5]= "./spritesheet/frame6.png";
	animTexName[6]= "./spritesheet/frame7.png";
	animTexName[7]= "./spritesheet/frame8.png";
	animTexName[8]= "./spritesheet/frame9.png";
	animTexName[9]= "./spritesheet/frame10.png";
	animTexName[10]= "./spritesheet/frame11.png";
	animTexName[11]= "./spritesheet/frame12.png";
	animTexName[12]= "./spritesheet/frame13.png";
	animTexName[13]= "./spritesheet/frame14.png";
	animTexName[14]= "./spritesheet/frame15.png";
	animTexName[15]= "./spritesheet/frame16.png";
	animTexName[16]= "./spritesheet/frame17.png";
	animTexName[17]= "./spritesheet/frame18.png";
	animTexName[18]= "./spritesheet/frame19.png";
	animTexName[19]= "./spritesheet/frame20.png";
	animTexName[20]= "./spritesheet/frame21.png";
	animateTexture= true;
	framesPerSec= 21;
	
	sizes[0] = 8.0;
	sizes[1] = 8.0;
};


datablock particleEmitterData(duckExplosionEmitter)
{
	ejectionPeriodMS = 1000;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = duckExplosionParticle;

   useEmitterColors = false;
   uiName = "Ducksplosion";
};

datablock ExplosionData(duckExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 75;

   soundProfile = duckCannonExplosionSound;

   ParticleEmitter = duckExplosionEmitter;
   particleDensity = 1;
   particleRadius = 0.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 15;
   lightEndRadius = 11;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 6.5;
   impulseForce = 2000;

   //radius damage
   radiusDamage        = 120;
   damageRadius        = 3.5;
};

AddDamageType("DuckDirect",   '<bitmap:add-ons/Weapon_DuckCannon/CI_Duck> %1',       '%2 <bitmap:add-ons/Weapon_DuckCannon/CI_Duck> %1',1,1);
AddDamageType("DuckRadius",   '<bitmap:add-ons/Weapon_DuckCannon/CI_Duck> %1', '%2 <bitmap:add-ons/Weapon_DuckCannon/CI_Duck> %1',1,0);
datablock ProjectileData(DuckProjectile)
{
   projectileShapeName = "./duck.dts";
   directDamage        = 0;
   directDamageType  = $DamageType::DuckDirect;
   radiusDamageType  = $DamageType::DuckRadius;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   explosion           = duckExplosion;
   //particleEmitter     = "";

   brickExplosionRadius = 0;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;
   
   explodeOnDeath		= true;

   muzzleVelocity      = 15;
   velInheritFactor    = 1;

   armingDelay         = 1000;
   lifetime            = 9000;
   fadeDelay           = 9000;
   bounceElasticity    = 0.999;
   bounceFriction      = 0.8;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Duck";
};

datablock ItemData(DuckCannonItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./duckCannon.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Duck Cannon";
	iconName = "./icon_duckCannon";
	doColorShift = false;
	//colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = DuckCannonImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DuckCannonImage)
{
   // Basic Item properties
   shapeFile = "./duckcannon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = DuckCannonItem;
   ammo = " ";
   projectile = DuckProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   //colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 1.0;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	stateSound[2]					= DuckCannonChargeSound;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 1.0;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;


	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 2.0;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= duckCannonFireSound;
};

function DuckCannonImage::onFire(%this, %obj, %slot)
{
	serverPlay3D(duckCannonQuackSound, %obj.getPosition());
	parent::onFire(%this, %obj, %slot);
}
